#include <iostream>
#include <vector>

#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;


struct Input {
    std:: vector <double> numbers;
    size_t bin_count;
};


 Input input_data(istream& inp, bool prompt) {
Input in;
if (prompt){
size_t number_count;
cerr << "Enter number count: "; inp >> number_count;


in.numbers.resize(number_count);
 for (size_t i = 0; i < number_count; i++) {
        cerr << "Enter [" << i << "]: "; inp >> in.numbers[i];
    }

in.bin_count;
cerr << "Enter bin count: "; inp >> in.bin_count;
}
else {
    size_t number_count;
     inp >> number_count;



in.numbers.resize(number_count);
 for (size_t i = 0; i < number_count; i++) {
        inp >> in.numbers[i];
    }

in.bin_count;
inp >> in.bin_count;
}
    return in;
}



int main(int argc, char* argv[])
{

    if (argc>1){
       CURL* curl = curl_easy_init();
       if (curl) {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            res = curl_easy_perform(curl);
            curl_easy_cleanup(curl);
        }
return 0;
    }

 curl_global_init(CURL_GLOBAL_ALL);

unsigned int  n;
bool prompt=true;
auto in = input_data(cin, prompt);
double min,max;
auto  bins = make_histogram(in.numbers, in.bin_count);

show_histogram_svg ( bins );

return 0;
}
